﻿;[updated: 2017-04-15]
;updated by jeeswg to make it AHK v1/v2 two-way compatible

; http://www.autohotkey.com/board/topic/77303-acc-library-ahk-l-updated-09272012/
; https://dl.dropbox.com/u/47573473/Web%20Server/AHK_L/Acc.ahk
;------------------------------------------------------------------------------
; Acc.ahk Standard Library
; by Sean
; Updated by jethrow:
;   Modified ComObjEnwrap params from (9,pacc) --> (9,pacc,1)
;   Changed ComObjUnwrap to ComObjValue in order to avoid AddRef (thanks fincs)
;   Added Acc_GetRoleText & Acc_GetStateText
;   Added additional functions - commented below
;   Removed original Acc_Children function
; last updated 2/25/2010
;------------------------------------------------------------------------------
;NOTE 先查看AccViewer上的Hwnd为控件还是窗口

; hy add
;有可能 child_path 的第一级有误，需要手工添加
;url := Acc_GetChildByPath(win. "4.1.2.1.4.7.2").accValue(0)
Acc_GetChildByPath(Acc, child_path)
{
    loop parse, child_path, "."
    {
        if (A_LoopField = "P") ;很少
            Acc := Acc_Parent(Acc)
        else
        {
            Acc := Acc_GetChildByIdx(Acc, A_LoopField)
            if !isobject(Acc)
                return Acc
        }
    }
    return Acc
}
Acc_GetChildByIdx(Acc, idx)
{
    cnt := Acc.accChildCount
    if (!cnt || cnt < idx)
    {
        msgbox(format("{1}/{2}`n超出范围",idx,cnt))
        return
        ;throw ;有异常(比如网页未完成加载)
    }
    if dllcall("oleacc\AccessibleChildren", "Ptr",ComObjValue(Acc), "Int",0, "Int",cnt, "Ptr",VarSetCapacity(children,cnt*(8+2*A_PtrSize),0)*0+&children, "Int*",cnt)=0 
    {
        i := (idx-1)*(A_PtrSize*2+8) + 8
        item := NumGet(children, i)
        return ComObject(9, ComObjQuery(item,"{618736e0-3c3d-11cf-810c-00aa00389b71}"), 1)
    }
}
Acc_view(acc)
{
    try
        return acc.accName(0) . "`t" . acc.accValue(0) . "`t" . acc.accRole(0) . "`t" . acc.accChildCount
}

; 以下是原版
Acc_Init()
{
    static h
    if !h
        h:=dllcall("LoadLibrary", "Str","oleacc","Ptr")
}

Acc_ObjectFromEvent(ByRef _idChild_, hWnd, idObject, idChild)
{
    Acc_Init()
    if dllcall("oleacc\AccessibleObjectFromEvent", "Ptr", hWnd, "UInt", idObject, "UInt", idChild, "Ptr*", pacc, "Ptr", VarSetCapacity(varChild,8+2*A_PtrSize,0)*0+&varChild)=0
    {
        _idChild_:=NumGet(varChild,8,"UInt")
        ObjAddRef(pacc)
        return ComObject(9,pacc,1)
    }
}

Acc_ObjectFromPoint(ByRef _idChild_:="", x:="", y:="") ;x,y为screen坐标
{
    Acc_Init()
    if dllcall("oleacc\AccessibleObjectFromPoint", "Int64"
        , x==""||y==""
        ? 0*dllcall("GetCursorPos","Int64*",pt)+pt
        : x&0xFFFFFFFF|y<<32, "Ptr*", pacc, "Ptr", VarSetCapacity(varChild,8+2*A_PtrSize,0)*0+&varChild)=0
    {
        _idChild_:=NumGet(varChild,8,"UInt")
        ObjAddRef(pacc)
        return ComObject(9,pacc,1)
    }
}

Acc_ObjectFromWindow(hWnd, idObject:=-4)
{
    Acc_Init()
    ;if dllcall("oleacc\AccessibleObjectFromWindow", "ptr",hWnd, "uint",0, "ptr",-VarSetCapacity(IID,16)+NumPut(0x719B3800AA000C81,NumPut(0x11CF3C3D618736E0,IID,"int64"),"int64"), "ptr*",pacc)=0
    if dllcall("oleacc\AccessibleObjectFromWindow", "Ptr", hWnd, "UInt", idObject&=0xFFFFFFFF, "Ptr", -VarSetCapacity(IID,16)+NumPut(idObject==0xFFFFFFF0?0x46000000000000C0:0x719B3800AA000C81,NumPut(idObject==0xFFFFFFF0?0x0000000000020400:0x11CF3C3D618736E0,IID,"Int64"),"Int64"), "Ptr*", pacc)=0
    {
        ObjAddRef(pacc)
        return ComObject(9,pacc,1)
    }
}

Acc_WindowFromObject(pacc)
{
    if dllcall("oleacc\WindowFromAccessibleObject", "Ptr", isobject(pacc)?ComObjValue(pacc):pacc, "Ptr*", hWnd)=0
        return hWnd
}

Acc_GetRoleText(nRole)
{
    nSize := dllcall("oleacc\GetRoleText", "Uint", nRole, "Ptr", 0, "Uint", 0)
 VarSetCapacity(sRole, (A_IsUnicode?2:1)*nSize)
    dllcall("oleacc\GetRoleText", "Uint", nRole, "str", sRole, "Uint", nSize+1)
    return sRole
}

Acc_GetStateText(nState)
{
    nSize := dllcall("oleacc\GetStateText", "Uint", nState, "Ptr", 0, "Uint", 0)
 VarSetCapacity(sState, (A_IsUnicode?2:1)*nSize)
    dllcall("oleacc\GetStateText", "Uint", nState, "str", sState, "Uint", nSize+1)
    return sState
}

Acc_SetWinEventHook(eventMin, eventMax, pCallback)
{
    return dllcall("SetWinEventHook", "Uint", eventMin, "Uint", eventMax, "Uint", 0, "Ptr", pCallback, "Uint", 0, "Uint", 0, "Uint", 0)
}

Acc_UnhookWinEvent(hHook)
{
    return dllcall("UnhookWinEvent", "Ptr", hHook)
}
/* Win Events:

pCallback := RegisterCallback("WinEventProc")
WinEventProc(hHook, event, hWnd, idObject, idChild, eventThread, eventTime)
{
    critical
    Acc := Acc_ObjectFromEvent(_idChild_, hWnd, idObject, idChild)
    ; Code Here:

        }
*/

; Written by jethrow
Acc_Role(Acc, ChildId:=0) {
    try return ComObjType(Acc,"Name")="IAccessible"?Acc_GetRoleText(Acc.accRole(ChildId)):"invalid object"
}
Acc_State(Acc, ChildId:=0) {
    try return ComObjType(Acc,"Name")="IAccessible"?Acc_GetStateText(Acc.accState(ChildId)):"invalid object"
}
Acc_Location(Acc, ChildId:=0, ByRef Position:="") { ; adapted from Sean's code
    try
        Acc.accLocation(ComObject(0x4003,&x:=0), ComObject(0x4003,&y:=0), ComObject(0x4003,&w:=0), ComObject(0x4003,&h:=0), ChildId)
    catch
        return
    Position := "x" NumGet(x,0,"int") " y" NumGet(y,0,"int") " w" NumGet(w,0,"int") " h" NumGet(h,0,"int")
    return {x:NumGet(x,0,"int"), y:NumGet(y,0,"int"), w:NumGet(w,0,"int"), h:NumGet(h,0,"int")}
}
Acc_Parent(Acc) {
    try parent:=Acc.accParent
        return parent?Acc_Query(parent):""
}
Acc_Child(Acc, ChildId:=0) {
    try child:=Acc.accChild(ChildId)
        return child?Acc_Query(child):""
}
Acc_Query(Acc) { ; thanks Lexikos - www.autohotkey.com/forum/viewtopic.php?t=81731&p=509530#509530
    try return ComObject(9, ComObjQuery(Acc,"{618736e0-3c3d-11cf-810c-00aa00389b71}"), 1)
}
Acc_Error(p:="") {
    static setting:=0
    return p=""?setting:setting:=p
}
Acc_Children(Acc) {
    if ComObjType(Acc,"Name") != "IAccessible"
        errorlevel := "Invalid IAccessible object"
    else {
        Acc_Init(), cChildren:=Acc.accChildCount, Children:=[]
        if dllcall("oleacc\AccessibleChildren", "Ptr",ComObjValue(Acc), "Int",0, "Int",cChildren, "Ptr",VarSetCapacity(varChildren,cChildren*(8+2*A_PtrSize),0)*0+&varChildren, "Int*",cChildren)=0 {
            loop(cChildren)
                i:=(A_Index-1)*(A_PtrSize*2+8)+8, child:=NumGet(varChildren,i), Children.push(NumGet(varChildren,i-8)=9?Acc_Query(child):child), NumGet(varChildren,i-8)=9?ObjRelease(child):""
            return Children.length()?Children:""
        } else
        errorlevel := "AccessibleChildren dllcall Failed"
    }
    if Acc_Error()
        throw exception(errorlevel,-1)
}
Acc_ChildrenByRole(Acc, Role) {
    if ComObjType(Acc,"Name")!="IAccessible"
        errorlevel := "Invalid IAccessible object"
    else {
        Acc_Init(), cChildren:=Acc.accChildCount, Children:=[]
        if dllcall("oleacc\AccessibleChildren", "Ptr",ComObjValue(Acc), "Int",0, "Int",cChildren, "Ptr",VarSetCapacity(varChildren,cChildren*(8+2*A_PtrSize),0)*0+&varChildren, "Int*",cChildren)=0 {
            loop(cChildren) {
                i:=(A_Index-1)*(A_PtrSize*2+8)+8, child:=NumGet(varChildren,i)
                if NumGet(varChildren,i-8)=9
                    AccChild:=Acc_Query(child), ObjRelease(child), Acc_Role(AccChild)=Role?Children.push(AccChild):""
                else
                    Acc_Role(Acc, child)=Role?Children.push(child):""
            }
            errorlevel:=0
            return Children.length()?Children:""
        } else
        errorlevel := "AccessibleChildren dllcall Failed"
    }
    if Acc_Error()
        throw exception(errorlevel,-1)
}
Acc_Get(Cmd, ChildPath:="", ChildID:=0, WinTitle:="", WinText:="", ExcludeTitle:="", ExcludeText:="") {
    static properties := {Action:"DefaultAction", DoAction:"DoDefaultAction", Keyboard:"KeyboardShortcut"}
    AccObj :=   isobject(WinTitle)? WinTitle
        :   Acc_ObjectFromWindow( WinExist(WinTitle, WinText, ExcludeTitle, ExcludeText), 0 )
    if ComObjType(AccObj, "Name") != "IAccessible"
        errorlevel := "Could not access an IAccessible object"
    else {
        ChildPath := StrReplace(ChildPath, "_", A_Space)
        AccError:=Acc_Error(), Acc_Error(true)
        loop parse, ChildPath, ".", A_Space
            try {
                if (A_LoopField ~= "^\d*$")
                    Children:=Acc_Children(AccObj), m2:=A_LoopField ; mimic "m2" output in else-statement
                else
                    RegExMatch(A_LoopField, "(\D*)(\d*)", m), Children:=Acc_ChildrenByRole(AccObj, m[1]), m[2]:=(m[2]?m[2]:1)
                if !Children.haskey(m[2])
                    throw
                AccObj := Children[m[2]]
            } catch {
                errorlevel:="Cannot access ChildPath Item #" A_Index " -> " A_LoopField, Acc_Error(AccError)
                if Acc_Error()
                    throw exception("Cannot access ChildPath Item", -1, "Item #" A_Index " -> " A_LoopField)
                return
            }
            Acc_Error(AccError)
            Cmd := StrReplace(Cmd, A_Space, "")
            properties.haskey(Cmd)? Cmd:=properties[Cmd]:""
            try {
                if (Cmd = "Location")
                    AccObj.accLocation(ComObject(0x4003,&x:=0), ComObject(0x4003,&y:=0), ComObject(0x4003,&w:=0), ComObject(0x4003,&h:=0), ChildId)
                        , ret_val := "x" NumGet(x,0,"int") " y" NumGet(y,0,"int") " w" NumGet(w,0,"int") " h" NumGet(h,0,"int")
                    else if (Cmd = "object")
                        ret_val := AccObj
                    else if (Cmd ~= "^(Role|State)$")
                        ret_val := Acc_%Cmd%(AccObj, ChildID+0)
                    else if (Cmd ~= "^(ChildCount|selection|focus)$")
                        ret_val := AccObj["acc" . Cmd]
                    else
                        ret_val := AccObj["acc" . Cmd].call(ChildID+0)
            } catch {
                errorlevel := chr(34) Cmd chr(34) " Cmd not Implemented"
                if Acc_Error()
                    throw exception("Cmd not Implemented", -1, Cmd)
                return
            }
            errorlevel:=0
            return ret_val
    }
    if Acc_Error()
        throw exception(errorlevel,-1)
}
